<?php

namespace App\Controllers\Admin\Customer;

use App\Helpers\Customer\ServiceHelper;
use App\Services\Customer\ServicePaymentService;

use App\Services\Customer\ServiceService;
use App\Services\Equipment\CodeService;
use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class ServiceController extends CustomerController
{
    private ?CodeService $_codeService = null;
    private ?ServicePaymentService $_servicePaymentService = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->content_title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    public function getService(): ServiceService
    {
        if (!$this->_service) {
            $this->_service = new ServiceService();
        }
        return $this->_service;
    }
    public function getHelper(): ServiceHelper
    {
        if (!$this->_helper) {
            $this->_helper = new ServiceHelper();
        }
        return $this->_helper;
    }
    public function getCodeService(): CodeService
    {
        if (!$this->_codeService) {
            $this->_codeService = new CodeService();
        }
        return $this->_codeService;
    }
    public function getServicePaymentService(): ServicePaymentService
    {
        if (!$this->_servicePaymentService) {
            $this->_servicePaymentService = new ServicePaymentService();
        }
        return $this->_servicePaymentService;
    }
    protected function getResultSuccess(string $message = MESSAGES["SUCCESS"], ?string $actionTemplate = null): RedirectResponse|string
    {
        switch ($this->getAction()) {
            case 'index':
            case 'view':
                $result = parent::getResultSuccess($message, $this->request->getVar('ActionTemplate') ?? $actionTemplate ?? 'service');
                break;
            default:
                $result = parent::getResultSuccess($message, $actionTemplate);
                break;
        }
        return $result;
    }
    //Index,FieldForm관련
    //생성관련
    protected function create_process(array $formDatas): void
    {
        // 관리자 UID는 현재 인증된 사용자로 설정
        $formDatas['user_uid'] = $this->getMyAuth()->getUIDByAuthInfo();
        parent::create_process($formDatas);
    }
    //수정관련
    protected function modify_process(mixed $entity, array $formDatas): void
    {
        // 관리자 UID는 현재 인증된 사용자로 설정
        $formDatas['user_uid'] = $this->getMyAuth()->getUIDByAuthInfo();
        parent::modify_process($entity, $formDatas);
    }
    //View 관련
    protected function view_process(mixed $entity): void
    {
        //LINE,IP,SERVER등 추가 FilterOption 셋팅용
        $this->setFilterOptionsByItemType();
        //각각의 Item항목 정의
        $this->getService()->setItemEntitiesByService($entity);
        //부모처리
        parent::view_process($entity);
    }
    //Delete 관련
    protected function delete_process(mixed $entity): void
    {
        //각각의 Item항목 정의
        $entity = $this->getService()->setItemEntitiesByService($entity);
        //부모처리
        parent::delete_process($entity);
    }
    //List 관련
    protected function index_process(): void
    {
        //서비스별 미납 Count
        $this->unPaids = $this->getServicePaymentService()->getUnPaidCountByService();
        //LINE,IP,SERVER등 추가 FilterOption 셋팅용
        $this->setFilterOptionsByItemType();
        //부모함수처리
        parent::index_process();
        //추가처리
        $entities = [];
        foreach ($this->entities as $entity) {
            //각각의 Item항목 정의
            $entities[$entity->getPK()] = $this->getService()->setItemEntitiesByService($entity);
        }
        $this->entities = $entities;
    }
}
